<template>
    <div>
        <div class="agenda-list">
            <q-list separator style="margin-bottom: 40px" v-if="agenda.length > 0">
                <q-item v-for="(item, index) in agenda" :key="index" class="q-px-none">
                    <q-card class="agenda-item">
                        <q-card-section>
                            <p class="agenda-topic">
                                {{ `#${index + 1}: ${item.Topic}` }}
                            </p>
                            <p class="agenda-notes">{{ item.Notes }}</p>
                            <small>{{ getNames(item.Attendees) }}</small>
                        </q-card-section>
                        <div class="item-controls">
                            <small style="margin-right: 10px;">{{
                                $t("schedule_session.section_4.length", [item.Minutes])
                            }}</small>
                            <q-btn style="margin-right: 10px; color: grey" flat round icon="edit"
                                @click="handleEditItem(index)" />
                            <q-btn color="negative" flat round icon="delete" @click="handleDeleteItem(index)" />
                        </div>
                    </q-card>
                </q-item>
            </q-list>
            <div class="q-ma-lg" v-else>
                <p>{{ $t("schedule_session.section_4.no_agenda") }}</p>
            </div>

            <q-btn color="primary" rounded icon="add" @click="addAgendaItem()">
                &nbsp; {{ $t(`schedule_session.section_4.add_agenda_item`) }}
            </q-btn>
        </div>

        <q-dialog v-model="showAddItemDialog">
            <q-card v-if="editing" style="min-width: 33%">
                <q-form ref="formRef" @submit="handleUpdateAgendaItem" @reset="handleResetForm">
                    <q-card-section class="q-pb-none">
                        <h6 class="q-my-sm">
                            {{
    $t(
                            `schedule_session.section_4.${editingExisting? "edit_agenda_item" : "add_agenda_item"}`
                            ) }}
                        </h6>

                        <q-input :label="$t('schedule_session.section_4.edit_topic')" :rules="[
                            (val) =>
                                (val && val.length > 0) ||
                                $t('schedule_session.section_4.edit_no_topic'),
                        ]" filled v-model="editing.Topic" />
                        <q-input :label="$t('schedule_session.section_4.edit_notes')" filled v-model="editing.Notes" />

                        <div class="row items-center" style="margin-top:20px">
                            <p style="margin:10px;">Length in minutes:</p>
                            <q-input v-model.number="editing.Minutes" type="number" filled style="max-width: 100px"
                                :rules="[
                                    val => !!val || $t('schedule_session.section_4.length_error'),
                                    val => val >= 1 || $t('schedule_session.section_4.length_error')
                                ]" />
                        </div>

                        <q-expansion-item expand-separator icon="perm_identity" style="margin-top: 20px"
                            :label="$t('schedule_session.section_4.edit_attendees')"
                            :caption="getNames(editing.Attendees)">
                            <q-card>
                                <q-card-section>
                                    <q-list separator style="margin-bottom: 30px">
                                        <q-item v-for="(contact, phoneNumber) in participantsMinusHost"
                                            :key="phoneNumber" class="q-px-none">
                                            <q-item-section side>
                                                <q-checkbox v-model="editing.Attendees" :val="phoneNumber"
                                                    :disable="phoneNumber == usersPhone" />
                                            </q-item-section>
                                            <q-item-section>
                                                <q-item-label>{{ contact.Name }}</q-item-label>
                                                <q-item-label caption>{{ phoneNumber }}</q-item-label>
                                            </q-item-section>
                                        </q-item>
                                    </q-list>
                                </q-card-section>
                            </q-card>
                        </q-expansion-item>
                    </q-card-section>
                    <div class="row items-center justify-between" style="margin: 20px">
                        <q-space />
                        <q-btn type="submit" color="primary" rounded :icon-right="editingExisting ? 'save' : 'add'">
                            {{
                            $t(
                            `invite_arbitrary_number.${
    editingExisting ? "save_person" : "add_person"
}`
                            )
                            }}&nbsp;
                        </q-btn>
                    </div>
                </q-form>
            </q-card>
        </q-dialog>
    </div>
</template>
  
<script>
export default {
    props: {
        participants: {
            required: true,
        },
        usersPhone: {
            required: true,
            type: String,
        },
        agenda: {
            default()
            {
                return [];
            },
        },
        saveChanges: {
            type: Function
        }
    },
    data()
    {
        return {
            showAddItemDialog: false,
            editingExisting: false,
            editingClean: {
                Topic: "",
                Notes: "",
                Attendees: [],
                Minutes: 10
            },
            editing: {},
        };
    },
    computed: {
        participantsMinusHost()
        {
            let toRet = {};
            Object.keys(this.participants ?? {}).forEach((num) =>
            {
                if (num != this.usersPhone)
                {
                    toRet[num] = this.participants[num];
                }
            });

            return toRet;
        },
    },
    methods: {
        getNames(phoneNums)
        {
            if (!phoneNums || phoneNums.length == 0)
            {
                return this.$t("schedule_session.section_4.no_attendees_selected");
            }

            let names = [];

            phoneNums.forEach((num) =>
            {
                names.push(this.participants[num].Name);
            });

            return this.$t("schedule_session.section_4.attendees_selected", [
                names.join(", "),
            ]);
        },
        addAgendaItem()
        {
            this.editingExisting = false;
            this.editing = JSON.parse(JSON.stringify(this.editingClean));
            this.editing.Index = this.agenda.length;

            if (this.editing.Index > 0)
            {
                this.editing.Attendees = this.agenda[this.editing.Index - 1].Attendees ?? [];
            }

            this.showAddItemDialog = true;
        },
        handleUpdateAgendaItem()
        {
            if (this.saveChanges)
            {
                // don't edit local version, that should be updated from DB
                let copy = JSON.parse(JSON.stringify(this.agenda));
                copy[this.editing.Index] = this.editing;
                this.saveChanges(copy);
            }
            else
            {
                this.agenda[this.editing.Index] = this.editing;
            }

            this.showAddItemDialog = false;
        },
        handleAddRemoveAttendee(phoneNumber)
        {
            const index = this.editing.Attendees.indexOf(phoneNumber);
            if (index >= 0)
            {
                this.editing.Attendees.splice(index, 1);
            } else
            {
                this.editing.Attendees.push(phoneNumber);
            }
        },
        handleResetForm()
        {
            this.editing = JSON.parse(JSON.stringify(this.editingClean));
        },
        handleEditItem(index)
        {
            this.editing = {};
            this.editingExisting = true;
            // Copy values so we're not directly editing the data in realtime
            this.editing = JSON.parse(JSON.stringify(this.agenda[index]));
            this.editing.Index = index;
            this.showAddItemDialog = true;
        },
        handleDeleteItem(index)
        {
            this.$q
                .dialog({
                    title: this.$t("schedule_session.section_4.delete_confirm_title"),
                    message: this.$t("schedule_session.section_4.delete_confirm_message"),
                    ok: { label: this.$t("confirm"), flat: true, color: "negative" },
                    cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
                })
                .onOk(() => 
                {
                    if (this.saveChanges)
                    {
                        // don't edit local version, that should be updated from DB
                        let copy = JSON.parse(JSON.stringify(this.agenda));
                        copy.splice(index, 1);
                        this.saveChanges(copy);
                    }
                    else
                    {
                        this.agenda.splice(index, 1);
                    }
                });
        },
    },
};
</script>
  
<style scoped>
.stacked-btn-wrapper {
    display: inline-block;
    text-align: right;
}

.bottom-spacer {
    margin-bottom: 30px;
}

.agenda-list {
    text-align: center;
    margin-bottom: 80px;
}

.agenda-item {
    width: 90%;
    margin: auto;
    padding: 5px;
    text-align: left;
}

.agenda-topic {
    margin-bottom: 8px;
    font-size: 18px;
    font-weight: bold;
}

.agenda-notes {
    margin-bottom: 8px;
    font-size: 14px;
}

.item-controls {
    float: right;
    margin-right: 20px;
}

@media only screen and (min-width: 1000px) {
    .bottom-spacer {
        margin-bottom: 50px;
    }
}
</style>
